/**   
* @Package     : com.ccb.mobile.platform
* @Copyright   : @版权所有 中国建设银行版权所有
* @Description : TODO(用一句话描述该文件做什么)
* Administrator   
* 2014-4-25
* @version     : v1.0   
*/

package com.ccb.mobile.platform.bean;

import java.io.Serializable;

import android.content.Context;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.telephony.TelephonyManager;
import android.util.DisplayMetrics;
import android.view.WindowManager;

/**
 * @ClassName    : AppInfo
 * @Description  : TODO(这里用一句话描述这个类的作用)
 * @author       : LiangYJ
 * @date         : 2014-4-25
 * 
 */
public class AppInfo implements Serializable{
	private static final long serialVersionUID = 1L;
	/**
	 * 应用名
	 */
	public String mAppName;
	/**
	 * 应用包名
	 */
	public String mPackageName;
	/**
	 * 应用版本名
	 */
	public String mVersionName;
	/**
	 * 应用版本号
	 */
	public String mVersionCode;
	/**
	 * 应用签名信息
	 */
	public String mSignatures;
	/**
	 * 设备号
	 */
	public String mDeviceId;
	/**
	 * 系统版本号
	 */
	public String mSysVersionName = "Android " + android.os.Build.VERSION.RELEASE;
	/**
	 * 分辨率
	 */
	public String mResolution;
	/**
	 * 页面版本号
	 */
	public String mPageVersion = "chinamworld";
	/**
	 * 手机型号设备信息
	 */
	public String mModel = android.os.Build.MODEL + "," +
						   android.os.Build.VERSION.SDK_INT + "," +
						   android.os.Build.VERSION.RELEASE; //Milestone,6,2.01
	/**
	 * 手机平台,操作系统信息
	 */
	public String mPlatform = "Android " + android.os.Build.VERSION.RELEASE;
	
	public static final AppInfo getAppInfo(Context context){
		AppInfo appInfo = new AppInfo();
		//获取包名,版本名,版本号,签名
		try {
			PackageManager manager = context.getPackageManager();
			String packageName = context.getPackageName();
			PackageInfo info = manager.getPackageInfo(packageName, PackageManager.GET_SIGNATURES);
			appInfo.mAppName = manager.getApplicationLabel(context.getApplicationInfo()).toString();
			appInfo.mPackageName = packageName;
			appInfo.mVersionName = info.versionName;
			appInfo.mVersionCode = String.valueOf(info.versionCode);
			appInfo.mSignatures = info.signatures[0].toCharsString();
		} catch (NameNotFoundException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		//获取设备号
		final TelephonyManager tm = (TelephonyManager) context.getSystemService(Context.TELEPHONY_SERVICE);
		appInfo.mDeviceId = tm.getDeviceId();
		//获取分辨率
		DisplayMetrics dm = new DisplayMetrics();
		((WindowManager) context.getSystemService(Context.WINDOW_SERVICE)).getDefaultDisplay().getMetrics(dm);
		appInfo.mResolution = dm.widthPixels + "*" + dm.heightPixels;
		
		return appInfo;
	}
}
