/**   
* @Package     : com.ccb.mobile.platform.bean
* @Copyright   : @版权所有 中国建设银行版权所有
* @Description : TODO(用一句话描述该文件做什么)
* @author      : dongguangyu   
* @date        : 2014-4-24
* @version     : v1.0   
*/

package com.ccb.mobile.platform.bean;

import java.util.HashMap;
import java.util.List;


public class SYS_TXATTR {
	
	private String txcode;//交易码
	private String txName;//交易名称
	private String channelType;//渠道类型
	private String submitType;//提交方式:POST和GET
	private String characterEncoding;//编码格式:GBK ISO8859-1 UTF-8
	private String pakageType;//报文体格式:json xml html
	private String url;//url链接地址，对直接请求形交易
	private String snPakid;//发送报文ID
	private String revPakid;//接收报文ID
	private List<SYS_PACKAGE> snpaks;//发送请求数据包
	private List<SYS_PACKAGE> revpaks;//交易返回数据包
	private String actionBefore;//发送请求前执行的检查，以"|"隔开的类名
	private String actionAfter;//交易返回后执行的检查，以"|"隔开的类名
	
	public SYS_TXATTR() {
		// TODO Auto-generated constructor stub
	}

	public String getTxcode() {
		return txcode;
	}

	public void setTxcode(String txcode) {
		this.txcode = txcode;
	}

	public String getTxName() {
		return txName;
	}

	public void setTxName(String txName) {
		this.txName = txName;
	}

	public String getChannelType() {
		return channelType;
	}

	public void setChannelType(String channelType) {
		this.channelType = channelType;
	}

	public String getSubmitType() {
		return submitType;
	}

	public void setSubmitType(String submitType) {
		this.submitType = submitType;
	}

	public String getCharacterEncoding() {
		return characterEncoding;
	}

	public void setCharacterEncoding(String characterEncoding) {
		this.characterEncoding = characterEncoding;
	}

	public String getPakageType() {
		return pakageType;
	}

	public void setPakageType(String pakageType) {
		this.pakageType = pakageType;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getSnPakid() {
		return snPakid;
	}

	public void setSnPakid(String snPakid) {
		this.snPakid = snPakid;
	}

	public String getRevPakid() {
		return revPakid;
	}

	public void setRevPakid(String revPakid) {
		this.revPakid = revPakid;
	}

	public List<SYS_PACKAGE> getSnpaks() {
		return snpaks;
	}

	public void setSnpaks(List<SYS_PACKAGE> snpaks) {
		this.snpaks = snpaks;
	}

	public List<SYS_PACKAGE> getRevpaks() {
		return revpaks;
	}

	public void setRevpaks(List<SYS_PACKAGE> revpaks) {
		this.revpaks = revpaks;
	}

	public String getActionBefore() {
		return actionBefore;
	}

	public void setActionBefore(String actionBefore) {
		this.actionBefore = actionBefore;
	}

	public String getActionAfter() {
		return actionAfter;
	}

	public void setActionAfter(String actionAfter) {
		this.actionAfter = actionAfter;
	}
	
	/**
	 * 
	* 如果是Method get请求方法，则将参数的和基本URL组合成新的请求串 
	* @param url 数据库中URL
	* @param params 请求参数
	* @return String: 返回类型
	 */
	public String getRequestUrl(String url,HashMap<String, String> params){
		StringBuilder sb = new StringBuilder();
		sb.append(url);
		if(snpaks != null && !snpaks.isEmpty() && null != url){
			//从params迭代必需的请求参数，必需的请求参数从数据中获取，保存在SYS_TXATTR的snpaks字段中
			for (SYS_PACKAGE sys_package : snpaks) {
				sb.append("&")
				  .append(sys_package.getTagId())
				  .append("=")
				  .append(params.get(sys_package.getTagId()));
			}
		}
		return sb.toString();
	}

	@Override
	public String toString() {
		return "SYS_TXATTR [txcode=" + txcode + ", txName=" + txName
				+ ", channelType=" + channelType + ", submitType=" + submitType
				+ ", characterEncoding=" + characterEncoding + ", pakageType="
				+ pakageType + ", url=" + url + ", snPakid=" + snPakid
				+ ", revPakid=" + revPakid + ", snpaks=" + snpaks
				+ ", revpaks=" + revpaks + ", actionBefore=" + actionBefore
				+ ", actionAfter=" + actionAfter + "]";
	}

	

}
