/**   
* @Package     : com.ccb.mobile.platform.parse.json
* @Copyright   : @版权所有 中国建设银行版权所有
* @Description : TODO(用一句话描述该文件做什么)
* Administrator   
* 2014-4-25
* @version     : v1.0   
*/

package com.ccb.mobile.platform.parse.json;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

/**
 * @ClassName    : JsonHelper
 * @Description  : TODO(这里用一句话描述这个类的作用)
 * @author       : LiangYJ
 * @date         : 2014-4-25
 * 
 */
public class JsonHelper {
	/**
	 * 
	* 将对象转换成Json 
	* @param object
	* @throws JSONException
	* @return Object: 返回类型
	 */
	public static Object toJson(Object object) throws JSONException{
		if(object instanceof Map){
			JSONObject json = new JSONObject();
			Map map = (Map) object;
			for (Object key : map.keySet()) {
				json.put(key.toString(), toJson(map.get(key)));
			}
			return json;
		}else if(object instanceof Iterable){
			JSONArray json = new JSONArray();
			for (Object value : ((Iterable) object)) {
				json.put(value);
			}
			return json;
		}else{
			return object;
		}
	}
	
	/**
	 * 
	* 判断JSONObject是否是一个空对像 
	* @param object
	* @return boolean: 返回类型
	 */
	public static boolean isEmptyObject(JSONObject object){
		return (object == null) || (object.names() == null);
	}
	
	/**
	 * 
	* 将JSONObejct转换成Map 
	* @param object JSONObject对象
	* @throws JSONException
	* @return Map<String,Object>: 返回类型
	 */
	public static HashMap<String,Object> toMap(JSONObject object) throws JSONException{
		HashMap<String, Object> map = new HashMap<String, Object>();
		Iterator keys = object.keys();
		while (keys.hasNext()) {
			String key = (String) keys.next();
			map.put(key, fromJson(object.get(key)));
		}
		return map;
	}

	/**
	 * 
	* 将JSONObejct转换成Map 
	* @param String json
	* @throws JSONException
	* @return Map<String,Object>: 返回类型
	 */
	public static HashMap<String,Object> toMap(String json) throws JSONException{
		Object object = new JSONTokener(json).nextValue();
		if(object instanceof JSONObject){
			return toMap(new JSONObject(json));
		}else if(object instanceof JSONArray){
			JSONArray array = (JSONArray) object;
			int length = array.length();
			HashMap <String,String> hs = null;
			for (int i = 0; i < length; i++) {
				//toMap(array.optJSONObject(i));
				
			}
			return null;
		}
		return null;
	}
	
	
	
	/**
	 * 
	* 通过key获取JSONObject的一个map
	* @param object
	* @param key
	* @return
	* @throws JSONException
	* @return Map<String,Object>: 返回类型
	 */
	public static Map<String,Object> getMap(JSONObject object, String key) throws JSONException{
		return toMap(object.getJSONObject(key));
	}
	
	/**
	 * 
	* 将JSONArray转换成List 
	* @param array
	* @return
	* @throws JSONException
	* @return List<Object>: 返回类型
	 */
	public static List<Object> toList(JSONArray array) throws JSONException{
		List<Object> list = new ArrayList<Object>();
		int length = array.length();
		for (int i = 0; i < length; i++) {
			list.add(fromJson(array.get(i)));
		}
		return list;
	}
	
	public static Object fromJson(Object json) throws JSONException{
		if(json == JSONObject.NULL){
			return null;
		}else if(json instanceof JSONObject){
			return toMap((JSONObject)json);
		}else if(json instanceof JSONArray){
			return toList((JSONArray)json);
		}else{
			return json;
		}
	}
	
	
	
}
