/**   
* @Package     : com.ccb.mobile.platform.system
* @Copyright   : @版权所有 中国建设银行版权所有
* @Description : TODO(用一句话描述该文件做什么)
* Administrator   
* 2014-4-25
* @version     : v1.0   
*/

package com.ccb.mobile.platform.system;

import java.util.ArrayList;
import java.util.HashMap;

import org.apache.http.client.CookieStore;
import org.apache.http.cookie.Cookie;
import org.json.JSONException;

import android.content.Context;
import android.text.TextUtils;
import android.util.Log;

import com.ccb.mobile.platform.Constants;
import com.ccb.mobile.platform.PlatformManager;
import com.ccb.mobile.platform.bean.SYS_TXATTR;
import com.ccb.mobile.platform.exception.NetworkException;
import com.ccb.mobile.platform.http.HttpClient;
import com.ccb.mobile.platform.http.HttpException;
import com.ccb.mobile.platform.http.Response;
import com.ccb.mobile.platform.utils.MbsLogManager;
import com.ccb.mobile.platform.utils.PlatformUtils;

/**
 * 生成Ebs(网银)系统,负责处理各种Ebs规则
 * @ClassName    : EbsSystem
 * @author       : LiangYJ
 * @date         : 2014-4-25
 * 
 */
public class CCBSystem extends BaseSystem<Object> {
	private static final HashMap<String, String> HEADER = new HashMap<String, String>(6);
	private static final String USER_AGENT = "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; Trident/4.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; InfoPath.2)";
	private static final String ACCEPT = "image/jpeg, application/x-ms-application, image/gif, application/xaml+xml, image/pjpeg, application/x-ms-xbap, application/vnd.ms-excel, application/vnd.ms-powerpoint, application/msword, */*";
	private static final String CONNECTION = "Keep_Alive";
	private static final String ACCEPT_LANGUAGE = "zh-cn,zh;q=0.5";
	private static final String ACCEPT_ENCODING = "gzip, deflate";
	private static final String REFERER = "http://life.ccb.com/cn";
	private static CookieStore mCookieStore;
	private static CCBSystem ccbSystem;
//	private static String mCookieString = "";
	
	static {
		HEADER.put("user-agent", USER_AGENT);
		HEADER.put("accept", ACCEPT);
		HEADER.put("Proxy-Connection", CONNECTION);
		HEADER.put("Accept-Language", ACCEPT_LANGUAGE);
		HEADER.put("Accept-Encoding", ACCEPT_ENCODING);
		HEADER.put("Referer", REFERER);
	}
	
	public CCBSystem(Context context) {
		super(context);
	}
	
	@Override
	protected String fectchFromCache() {
		String txcode = PlatformManager.getSysTxattr().getTxcode();
		String result = PlatformManager.getLocalResponse() != null ? PlatformManager.getLocalResponse().get(txcode):"";
		return result;
	}

	@Override
	protected boolean isCache() {
		String txcode = PlatformManager.getSysTxattr().getTxcode();
		if(PlatformManager.getLocalResponse() != null ){
			if(!TextUtils.isEmpty(PlatformManager.getLocalResponse().get(txcode))){
				return true;
			}
		}
		return false;	
	}

	/**
	*　1.网络请求类，采用单例模式。
	*　2.请求参数每次都必须重新赋值
	* This isCCBSystem.java class 
	* @param context 交易上下文
	* @param paras　交易请求参数
	* @return CCBSystem: 返回类型
	 */
	public static CCBSystem getCCBSystem(Context context,HashMap<String,String> paras){
		if(ccbSystem == null){
			ccbSystem = new CCBSystem(context);
		}
		return ccbSystem;
	}
	
	@Override
	public String request_String(String url, HashMap<String, String> params, final String chartSet, final boolean isCallIso_Gbk) {
		String result = null;
		if(isCache()){//交易配置档板文件
			result = fectchFromCache();
		}else{
			SYS_TXATTR sys_TXATTR = PlatformManager.getSysTxattr();

			HttpClient httpClient = getHttpClient(chartSet);
			setHttpClient(httpClient);
			httpClient.setHeaders(HEADER);
			
			if(mCookieStore != null){
				httpClient.setCookie(mCookieStore);
			}
			
			Response response = null;
			try {
				//Get方法
				if(sys_TXATTR.getSubmitType().equalsIgnoreCase(METHOD_GET)){
					if(TextUtils.isEmpty(sys_TXATTR.getUrl())){
						String request_url = getParamsUrl(url, params);
						response = httpClient.get(request_url);
					}else{
						String request_url = getParamsUrl(url+sys_TXATTR.getUrl(), params);
						response = httpClient.get(request_url);
					}
				//Post方法	
				}else if(sys_TXATTR.getSubmitType().equalsIgnoreCase(METHOD_POST)){
					response = httpClient.post(url, getBasicNameValuePairs(params));
				}
				
			} catch (HttpException e) {
				if(MbsLogManager.IS_DEBUG){
					e.printStackTrace();
				}
				throw new NetworkException(Constants.EXCEPTION_NETWORK_ERROR);
			}

			if(response != null){
				try {
					result = response.asString(chartSet, isCallIso_Gbk);
					result = PlatformUtils.subStr(result);
					if(PlatformUtils.checkHtmlErrorPage(result)){
						result = PlatformUtils.retHTMLErrMsg(result);
					}
					mCookieStore = httpClient.getCookie();
				}catch (Exception e) {
					if(MbsLogManager.IS_DEBUG){
						e.printStackTrace();
					}
					throw new NetworkException(Constants.EXCEPTION_NETWORK_ERROR);
				}
			}else{
				throw new NetworkException(Constants.EXCEPTION_NETWORK_ERROR);
			}
		}
		MbsLogManager.logD("CCBSystem sendRequest resutl:" + result);
		return result;
	}
	
  public static String getCookies() {
    if (mCookieStore == null) {
      return "";
    } else {
      for (Cookie cookie : mCookieStore.getCookies()) {
        if ("CCBIBS1".equals(cookie.getName()))
          return cookie.getValue();
      }
      return "";
    }
  }
	
	
}
