package com.ccb.mobile.platform.utils;

import java.util.HashMap;

import android.text.TextUtils;


public class PlatformUtils {

	public static boolean checkLastFlag(String str){
		boolean b = false;
		int lastFlag = str.lastIndexOf(",");
		if(lastFlag > 0){
			int indexOf2 = str.substring(lastFlag, str.length()).indexOf(":");
			if(indexOf2 < 0){
				b = true;
			}
		}
		
		return b;
	}
	
	public static String subStr(String str){
		StringBuilder sb = new StringBuilder();
		String result = str==null?"":str.trim();
		if(result != null && result.length() > 0 && checkLastFlag(result)){
			int lastFlagIndex = result.lastIndexOf(",");
			sb.append(result.substring(0, lastFlagIndex)).append(result.substring(lastFlagIndex+1, result.length()));
			result = sb.toString();
		}
		if (result != null && result.endsWith(";")) {
			result = result.substring(0, result.length() - 1);
		}
		if (result != null && result.endsWith(",")) {
			result = result.substring(0, result.length() - 1);
		}
		return result;
	}
	//检查当前请求是否为获取图片
	public static int checkNoTxcodeType(HashMap<String,String> params){
		int b = 0;
		if(params.get("PIC_URL") != null && params.get("PIC_URL").length()>0){
			b = 1;
		}else if(params.get("APP_VERSION") != null && params.get("APP_VERSION").length() > 0){
			b = 2;
		}else{
			 b = 3;
		}
		return b ;
	}
	
	//判断交易结果是否做两次编码转换
	public static boolean checkResonseEncoder(HashMap<String,String> hashMap,String txcode){
		if(hashMap != null && !TextUtils.isEmpty(txcode)){
			String txcodes = hashMap.get("ENCODE_ISO_GBK");
			if(txcodes != null && txcodes.contains(txcode)){
				MbsLogManager.logD("checkResonseEncoder::::"+txcodes+":"+txcode);
				return true;
			}
		}
		return false;
	}
	
	/**
	 * 服务端返回结果集判断
	* This isCCBSystem.java class 
	* @param jsonResult 服务端返回的结果集
	* @return boolean: 判断是否为html格式的错误页面,如果是ture，否则false
	 */
	public static boolean checkHtmlErrorPage(String jsonResult){
		boolean isHTML = false;
		if(jsonResult != null && jsonResult.contains("<html>") && jsonResult.contains("</html>")
				&& jsonResult.contains("<ErrCode>")){
			isHTML = true;
		}else{
			isHTML = false;
		}
		return isHTML;
	}
	/**
	 * 取出HTML格式页面的ErrCode,ErrMsg并组装成json或xml
	* This isCCBSystem.java class 
	* @param jsonResult
	* @return String: 返回类型
	 */
	public static String retHTMLErrMsg(String jsonResult){
		String errMsg = "",errCode = "";
		String retJson = "";
		if(jsonResult == null || "".equals(jsonResult.trim())){
			return retJson;
		}else{
			int codeStart = jsonResult.indexOf("<ErrCode>");
			int codeEnd = jsonResult.indexOf("</ErrCode>");
			int msgStart = jsonResult.indexOf("<ErrMsg>");
			int msgEnd = jsonResult.indexOf("</ErrMsg>");
			if (codeStart != -1 && msgStart != -1) {
				errCode = jsonResult.substring(codeStart + 9, codeEnd);
				errMsg = jsonResult.substring(msgStart + 8, msgEnd);
				
			}
			
			retJson = "{SUCCESS:false,ErrCode:"+errCode+",ErrMsg:"+errMsg+"}";
			
		}
		return retJson;
	}
	
		
}